
 {****************************************************************************}
 {                                                                            }
 {               FIBS Firebird-Interbase Backup Scheduler                     }
 {                                                                            }
 {                 Copyright (c) 2005-2006, Talat Dogan                       }
 {                                                                            }
 { This program is free software; you can redistribute it and/or modify it    }
 { under the terms of the GNU General Public License as published by the Free }
 { Software Foundation; either version 2 of the License, or (at your option)  }
 { any later version.                                                         }
 {                                                                            }
 { This program is distributed in the hope that it will be useful, but        }
 { WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY }
 { or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for}
 { more details.                                                              }
 {                                                                            }
 { You should have received a copy of the GNU General Public License along    }
 { with this program; if not, write to the Free Software Foundation, Inc.,    }
 { 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                      }
 {                                                                            }
 { Contact : dogantalat@yahoo.com
 {                                                                            }
 {****************************************************************************}


unit DModuleUnit;

interface

uses
  SysUtils, Classes, DB, DBClient, SdfData;

type
  TDModule = class(TDataModule)
    AlarmDS: TDataSource;
    OptionsDS: TDataSource;
    AlarmTable: TSdfDataSet;
    OptionsTable: TSdfDataSet;
    OptionsTablePATHTOGBAK: TStringField;
    OptionsTableLOGDIR: TStringField;
    OptionsTableTASKNO: TStringField;
    AlarmTableTASKNO: TStringField;
    AlarmTableTASKNAME: TStringField;
    AlarmTableDBNAME: TStringField;
    AlarmTableMIRRORDIR: TStringField;
    AlarmTableMIRROR2DIR: TStringField;
    AlarmTableUSER: TStringField;
    AlarmTableZIPBACKUP: TStringField;
    AlarmTableROLE: TStringField;
    AlarmTableBOPTIONS: TStringField;
    AlarmTableDELETEALL: TStringField;
    AlarmTableBOXES: TStringField;
    AlarmTableACTIVE: TStringField;
    AlarmTableBACKUPDIR: TStringField;
    AlarmTableBCOUNTER: TStringField;
    AlarmTableCOMPRESS: TStringField;
    AlarmTablePVAL: TStringField;
    AlarmTablePUNIT: TStringField;
    OptionsTableAUTORUN: TStringField;
    AlarmTableMIRROR3DIR: TStringField;
    OptionsTableBPRIORTY: TStringField;
    AlarmTableLOCALCONN: TStringField;
    AlarmTablePASSWORD: TStringField;
    AlarmTableDOVAL: TStringField;
    AlarmTableMAILTO: TStringField;
    OptionsTableSMTPSERVER: TStringField;
    OptionsTableSENDERSMAIL: TStringField;
    OptionsTableMAILUSERNAME: TStringField;
    OptionsTableMAILPASSWORD: TStringField;
    AlarmTableBATCHFILE: TStringField;
    AlarmTableSHOWBATCHWIN: TStringField;
    OptionsTableFTPCONNTYPE: TStringField;
    AlarmTableUSEPARAMS: TStringField;
    procedure DataModuleDestroy(Sender: TObject);
    procedure DataModuleCreate(Sender: TObject);
    procedure AlarmTableAfterInsert(DataSet: TDataSet);
    procedure OptionsTableAfterPost(DataSet: TDataSet);
    procedure AlarmTableAfterPost(DataSet: TDataSet);
    procedure AlarmTablePASSWORDGetText(Sender: TField; var Text: String;
      DisplayText: Boolean);
    procedure AlarmTablePASSWORDSetText(Sender: TField;
      const Text: String);
    procedure OptionsTableMAILPASSWORDSetText(Sender: TField;
      const Text: String);
    procedure OptionsTableMAILPASSWORDGetText(Sender: TField;
      var Text: String; DisplayText: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DModule: TDModule;

implementation

uses uTBase64, ConstUnit;

{$R *.dfm}

procedure TDModule.DataModuleDestroy(Sender: TObject);
begin
//   FABDatabase.Connected:=false;
end;

procedure TDModule.DataModuleCreate(Sender: TObject);
begin
  try
    OptionsTable.FileName:=DataFilesPath+'\prefs.dat';
    AlarmTable.FileName:=DataFilesPath+'\tasks.dat';
    DModule.OptionsTable.Open;
    DModule.AlarmTable.Open;
  except
    DataFilesInvalid:=true;
  end;
end;








procedure TDModule.AlarmTableAfterInsert(DataSet: TDataSet);
var
  TN:int64;
  StrTN:string;
begin
  StrTN:=OptionsTableTASKNO.AsString;
  if StrTN='' then TN:=0;
  TN:=StrToInt(OptionsTableTASKNO.Value);
  AlarmTableTASKNO.AsInteger:=TN;
  OptionsTable.Edit;
  OptionsTableTASKNO.AsInteger:=TN+1;
  OptionsTable.Post;
end;

procedure TDModule.OptionsTableAfterPost(DataSet: TDataSet);
begin
  OptionsTable.SaveFileAs(DataFilesPath+'\prefs.dat');
end;

procedure TDModule.AlarmTableAfterPost(DataSet: TDataSet);
begin
  AlarmTable.SaveFileAs(DataFilesPath+'\tasks.dat');
end;

procedure TDModule.AlarmTablePASSWORDGetText(Sender: TField;
  var Text: String; DisplayText: Boolean);
begin
  DecodeData(AlarmTablePASSWORD.Value,Text);
end;

procedure TDModule.AlarmTablePASSWORDSetText(Sender: TField;
  const Text: String);
 var
 s:string;
begin
  EncodeData(Text,s);
  AlarmTablePASSWORD.Value:=s;
end;

procedure TDModule.OptionsTableMAILPASSWORDSetText(Sender: TField;
  const Text: String);
var
 s:string;
begin
  EncodeData(Text,s);
  OptionsTableMAILPASSWORD.Value:=s;
end;

procedure TDModule.OptionsTableMAILPASSWORDGetText(Sender: TField;
  var Text: String; DisplayText: Boolean);
begin
  DecodeData(OptionsTableMAILPASSWORD.Value,Text);
end;

end.
