
 {****************************************************************************}
 {                                                                            }
 {               FIBS Firebird-Interbase Backup Scheduler                     }
 {                                                                            }
 {                 Copyright (c) 2005-2006, Talat Dogan                       }
 {                                                                            }
 { This program is free software; you can redistribute it and/or modify it    }
 { under the terms of the GNU General Public License as published by the Free }
 { Software Foundation; either version 2 of the License, or (at your option)  }
 { any later version.                                                         }
 {                                                                            }
 { This program is distributed in the hope that it will be useful, but        }
 { WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY }
 { or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for}
 { more details.                                                              }
 {                                                                            }
 { You should have received a copy of the GNU General Public License along    }
 { with this program; if not, write to the Free Software Foundation, Inc.,    }
 { 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                      }
 {                                                                            }
 { Contact : dogantalat@yahoo.com
 {                                                                            }
 {****************************************************************************}


unit ManualBackupUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Spin, CheckLst, DBCtrls;

type
  TManualBackupForm = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label5: TLabel;
    Label6: TLabel;
    EditDestinationDir: TEdit;
    EditDatabaseName: TEdit;
    Label7: TLabel;
    Label8: TLabel;
    EditUserName: TEdit;
    EditPassword: TEdit;
    Label3: TLabel;
    EditMirrorDir: TEdit;
    Label11: TLabel;
    EditTaskName: TEdit;
    Label1: TLabel;
    EditGBakDir: TEdit;
    Bevel1: TBevel;
    Label13: TLabel;
    CLBGbakOptions: TCheckListBox;
    DBCheckBox1: TDBCheckBox;
    LabelCompDegree: TLabel;
    EditCompDeg: TEdit;
    Label2: TLabel;
    EditPriority: TEdit;
    Label4: TLabel;
    EditMirror2Dir: TEdit;
    Label9: TLabel;
    EditMirror3Dir: TEdit;
    DBCheckBox2: TDBCheckBox;
    EditMailTo: TEdit;
    Label10: TLabel;
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ManualBackupForm: TManualBackupForm;

implementation

{$R *.dfm}
uses DateUtils, ConstUnit, DModuleUnit, MesajUnit, PresetsUnit;

procedure TManualBackupForm.BitBtn1Click(Sender: TObject);
var
 bd,md,dd,gd,ld:string;
begin
  if EditTaskName.text='' then
  begin
    MesajDlg('Task Name cannot be empty !',  'c',PrgName);
    ModalResult:=mrNone;
    exit;
  end;
  if DModule.AlarmTableLOCALCONN.AsBoolean=True then
  begin
    dd:=trim(EditDatabaseName.text);
    if (dd='') then
    begin
      MesajDlg('Database Path cannot be empty !',  'c',PrgName);
      ModalResult:=mrNone;
      exit;
    end else if FileExists(dd)=false then
    begin
      MesajDlg('Database doesn''t exist onto given path !'+#13#10+'('+dd+')',  'c',PrgName);
      ModalResult:=mrNone;
      exit;
    end;
  end;
  bd:=trim(EditDestinationDir.text);
  if (bd='') then
  begin
    MesajDlg('Backup Directory cannot be empty !',  'c',PrgName);
    ModalResult:=mrNone;
    exit;
  end else if DirectoryExists(bd)=false then
  begin
    MesajDlg('Backup directory is not exist !'+#13#10+'('+bd+')',  'c',PrgName);
    ModalResult:=mrNone;
    exit;
  end;

  if IsFtpPath(EditMirrorDir.text)=false then
  begin
    md:=trim(EditMirrorDir.text);
    if trim(md)='' then
    begin
      //    MesajDlg('Mirror path is empty !'#13#10'Mirroring has been disabled !',  'c',PrgName);
      // dikkat !!! mrNone yok ..exit yok..
    end else if DirectoryExists(md)=false then
    begin
      MesajDlg('Mirror directory is not exist !'+#13#10+'('+md+')',  'c',PrgName);
      ModalResult:=mrNone;
      exit;
    end else if (md=bd) then
    begin
      MesajDlg('Mirror directory must be different than Backup Directory !',  'c',PrgName);
      ModalResult:=mrNone;
      exit;
    end;
  end else
  begin
    if CheckFtpPath(EditMirrorDir.text)=false then
    begin
      ModalResult:=mrNone;
      exit;
    end;
  end;


  if IsFtpPath(EditMirror2Dir.text)=false then
  begin
    md:=trim(EditMirror2Dir.text);
    if trim(md)='' then
    begin
      //    MesajDlg('Mirror path is empty !'#13#10'Mirroring has been disabled !',  'c',PrgName);
      // dikkat !!! mrNone yok ..exit yok..
    end else if DirectoryExists(md)=false then
    begin
      MesajDlg('Mirror directory 2 is not exist !'+#13#10+'('+md+')',  'c',PrgName);
      ModalResult:=mrNone;
      exit;
    end else if (md=bd) then
    begin
      MesajDlg('Mirror directory 2 must be different than Backup Directory !',  'c',PrgName);
      ModalResult:=mrNone;
      exit;
    end;
  end else
  begin
    if CheckFtpPath(EditMirror2Dir.text)=false then
    begin
      ModalResult:=mrNone;
      exit;
    end;
  end;

  if IsFtpPath(EditMirror3Dir.text)=false then
  begin
    md:=trim(EditMirror3Dir.text);
    if trim(md)='' then
    begin
      //    MesajDlg('Mirror path is empty !'#13#10'Mirroring has been disabled !',  'c',PrgName);
      // dikkat !!! mrNone yok ..exit yok..
    end else if DirectoryExists(md)=false then
    begin
      MesajDlg('Mirror directory 3 is not exist !'+#13#10+'('+md+')',  'c',PrgName);
      ModalResult:=mrNone;
      exit;
    end else if (md=bd) then
    begin
      MesajDlg('Mirror directory 3 must be different than Backup Directory !',  'c',PrgName);
      ModalResult:=mrNone;
      exit;
    end;
  end else
  begin
    if CheckFtpPath(EditMirror3Dir.text)=false then
    begin
      ModalResult:=mrNone;
      exit;
    end;
  end;

  gd:=trim(EditGBakDir.text);
  if gd='' then
  begin
     MesajDlg('GBAK Directory is empty !',  'c',PrgName);
     ModalResult:=mrNone; //1.0.1
     exit;
  end else if DirectoryExists(gd)=false then
  begin
    MesajDlg('Gbak Directory doesn''t exists !!'+#13#10+'('+gd+')',  'c',PrgName);
    ModalResult:=mrNone;
    exit;
  end else if FileExists(gd+'\gbak.exe')=false then
  begin
    MesajDlg('Gbak.exe cannot be found onto given Gbak Dir !'+#13#10+'('+gd+')',  'c',PrgName);
    ModalResult:=mrNone;
    exit;
  end;
  ld:=trim(DModule.OptionsTableLOGDIR.value);
  if (ld='') then
  begin
    MesajDlg('LOG Directory is empty !',  'c',PrgName);
    ModalResult:=mrNone;
    exit;
  end else if DirectoryExists(ld)=false then
  begin
    MesajDlg('Given LOG Directory doesn''t exists !!!'+#13#10+'('+ld+')',  'c',PrgName);
    ModalResult:=mrNone;
    exit;
  end;

  if EditUserName.text='' then
  begin
    MesajDlg('User Name cannot be empty !',  'c',PrgName);
    ModalResult:=mrNone;
    exit;
  end;
  if EditPassword.text='' then
  begin
    MesajDlg('Password cannot be empty !',  'c',PrgName);
    ModalResult:=mrNone;
    exit;
  end;
end;

end.
